; ----------------------------------------------------------------------------
; RetroForth Release Series 8
; Version 3
; ----------------------------------------------------------------------------
include "../rx/macros"

format elf executable
entry main

main:
	pop dword [arg_count]
	pop dword [args]
	call bootstrap_rx

	upsh linux_boot
	upsh [linux_boot.size]
	call eval
	jmp boot

arg_count dd 0
args	  dd 0
code 'cmdline', _cmdline
	upsh [args]
next
code '#args', _num_args
	upsh [arg_count]
next
;---------------------------------------------------------------------
code 'syscall', _syscall

       ; syscalls can take a variable number of arguments, from 0 to 6.
       ; The args go in ebx, ecx, edx, esi, edi, ebp, in that order.
       ; (this is from the Linux Assembly HOWTO)

       ; At entry, the Forth stack holds args, argcount, syscall-number

       ; validate argcount, if > 6 return without changing the stack
           mov ecx, [esi]          ; ecx = argcount
           cmp ecx, 6
           ja .ret

           lea edi, [esi+4 +4*ecx] ; compute data stack adjustment
           push edi                ; save it
           push eax                ; save syscall-number
           mov eax, esi            ; esi modified when argcount>3
           neg ecx
           lea ecx, [.0 +3*ecx]  ; is ECX + ECX * 2
           jmp ecx

.6:        mov ebp, [eax+24]       ; 3-bytes instruction
.5:        mov edi, [eax+20]
.4:        mov esi, [eax+16]
.3:        mov edx, [eax+12]
.2:        mov ecx, [eax+8]
.1:        mov ebx, [eax+4]
.0:        pop eax                 ; restore syscall-number
           int 80h                 ; eax = syscall result
           pop esi                 ; restore adjusted data stack
.ret:      ret
;---------------------------------------------------------------------
linux_boot:
	include "../modules.inc"
	file "linux.f"
.size	dd $-linux_boot

;---------------------------------------------------------------------
code 'boot', boot
next
;---------------------------------------------------------------------
include "../rx/rx"
